# -*- coding: utf-8 -*-
from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.ATContentTypes.content.link import ATLink
from Products.azlinks.config import *

##code-section module-header #fill in your manual code here
from Products.Archetypes.public import DisplayList
from zope import interface
try:
    from Products.GenericSetup.interfaces import IDAVAware
    hasGenericSetup = True
except ImportError:
    hasGenericSetup = False
##/code-section module-header

copied_fields = {}
copied_fields['remoteUrl'] = ATLink.schema['remoteUrl'].copy()
copied_fields['remoteUrl'].index = "FieldIndex:brains"
schema = Schema((

    ComputedField(
        name='firstLetter',
        index="FieldIndex:brains",
        widget=ComputedWidget(
            label='Firstletter',
            label_msgid='azlinks_label_firstLetter',
            i18n_domain='azlinks',
        )
    ),

    copied_fields['remoteUrl'],
        StringField(
        name='selectedCategory',
        index="FieldIndex:brains",
        widget=SelectionWidget
        (
            label='Selectedcategory',
            label_msgid='azlinks_label_selectedCategory',
            i18n_domain='azlinks',
        ),
        vocabulary='allowedCategories'
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

AzLink_schema = getattr(ATLink, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class AzLink(ATLink):
    """
    """
    security = ClassSecurityInfo()

    # This name appears in the 'add' box
    archetype_name = 'AzLink'

    meta_type = 'AzLink'
    portal_type = 'AzLink'
    allowed_content_types = [] + list(getattr(ATLink, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'AzLink.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "AzLink"
    typeDescMsgId = 'description_edit_azlink'

    _at_rename_after_creation = True

    schema = AzLink_schema

    ##code-section class-header #fill in your manual code here
    if hasGenericSetup:
        interface.implements(IDAVAware)
    ##/code-section class-header

    # Methods

    security.declarePrivate('allowedCategories')
    def allowedCategories(self):
        """Return displaylist with allowed categories.

        The categories themselves are just grabbed from the
        AzLinkFolder we're in (through acquisition).
        """

        cats = self.getCategories()
        result = DisplayList([(cat, cat) for cat in cats])
        return result

    # Manually created methods

    def getFirstLetter(self):
        title = self.Title()
        if len(title) == 0:
            return ''
        firstLetter = title[0]
        return firstLetter.lower()



registerType(AzLink, PROJECTNAME)
# end of class AzLink

##code-section module-footer #fill in your manual code here
##/code-section module-footer



