# -*- coding: utf-8 -*-
import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

##code-section module-header #fill in your manual code here
from Products.Archetypes.public import DisplayList
##/code-section module-header

#
# Test-cases for class(es) AzLink
#

from Testing import ZopeTestCase
from Products.azlinks.config import *
from Products.azlinks.tests.MainTestCase import MainTestCase

# Import the tested classes
from Products.azlinks.content.AzLink import AzLink

##code-section module-beforeclass #fill in your manual code here
##/code-section module-beforeclass


class testAzLink(MainTestCase):
    """Test-cases for class(es) ."""

    ##code-section class-header_testAzLink #fill in your manual code here
    ##/code-section class-header_testAzLink

    def afterSetUp(self):
        self.setRoles(['Manager'])
        self.portal.invokeFactory('AzLinkFolder', id='az')
        self.portal.az.invokeFactory('AzLink', id='link')
        self.portal.az.setCategories(['Germany'])
        self.link = self.portal.az.link
        self.link.setTitle('Reinout is testing')
        self.link.setRemoteUrl('http://zestsoftware.nl')
        self.link.setSelectedCategory(['Germany'])
        self.link.reindexObject()

    # from class AzLink:
    def test_allowedCategories(self):
        self.portal.az.setCategories(['intercity', 'utrecht'])
        result = self.link.allowedCategories()
        self.assertEquals(len(result), 2)
        self.assertEquals(isinstance(result, DisplayList), True)

    # Manually created methods

    def testCatalogBrain(self):
        catalog = self.portal.portal_catalog
        query = {'portal_type': 'AzLink'}
        brains = catalog.searchResults(query)
        self.assertEquals(len(brains), 1)
        brain = brains[0]
        # We want the brain to have some attributes:
        self.assertEquals(brain.Title, 'Reinout is testing')
        self.assertEquals(brain.getFirstLetter, 'r')
        self.assertEquals(brain.getRemoteUrl,
                          'http://zestsoftware.nl')
        self.assertEquals(brain.getSelectedCategory, ['Germany',])

    def testGetFirstLetter(self):
        self.assertEquals(self.link.getFirstLetter(),
                          'r')

    def testOnlyAddableInAZLinkFolder(self):
        self.assertRaises(ValueError,
                          self.portal.invokeFactory,
                          'AzLink',
                          id='link')


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(testAzLink))
    return suite

##code-section module-footer #fill in your manual code here
##/code-section module-footer

if __name__ == '__main__':
    framework()


