# -*- coding: utf-8 -*-
import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

##code-section module-header #fill in your manual code here
from Products.azlinks.interfaces.azlinkfolderview import IAzLinkFolderView
##/code-section module-header

#
# Test-cases for class(es) AzLinkFolderView
#

from Testing import ZopeTestCase
from Products.azlinks.config import *
from Products.azlinks.tests.MainTestCase import MainTestCase

# Import the tested classes
from Products.azlinks.browser.folder import AzLinkFolderView

##code-section module-beforeclass #fill in your manual code here
##/code-section module-beforeclass


class testAzLinkFolderView(MainTestCase):
    """Test-cases for class(es) AzLinkFolderView."""

    ##code-section class-header_testAzLinkFolderView #fill in your manual code here
    ##/code-section class-header_testAzLinkFolderView

    def afterSetUp(self):
        self.setRoles(['Manager'])
        self.portal.invokeFactory('AzLinkFolder', id='az')
        self.az = self.portal.az

    # from class AzLinkFolderView:
    def test_azMatrix(self):
        view = self.az.restrictedTraverse('@@azlinks_view')
        results = view.azMatrix()
        # 5 rows
        self.assertEquals(len(results), 5)
        # 5 items per row
        row1 = results[0]
        row5 = results[4]
        self.assertEquals(len(row1), 5)
        self.assertEquals(len(row5), 5)
        # Check titles
        a = row1[0]
        self.assertEquals(a['title'], 'a')
        xy = row5[3]
        self.assertEquals(xy['title'], 'xy')
        # They also should have searchlink.
        self.assertEquals(a['searchLink'],
                          'http://nohost/plone/az?startLetter=a')
        self.assertEquals(xy['searchLink'],
                          'http://nohost/plone/az?startLetter=x&startLetter=y')

    # from class AzLinkFolderView:
    def test_categories(self):
        view = self.az.restrictedTraverse('@@azlinks_view')
        # Nothing added yet, so we only have 'all'
        results = view.categories()
        self.assertEquals(len(results), 1)
        all = results[0]
        self.assertEquals(all['title'], 'All')
        # We should have a search link
        self.assertEquals(all['searchLink'],
                          'http://nohost/plone/az?category=All')

    # from class AzLinkFolderView:
    def test_results(self):
        view = self.az.restrictedTraverse('@@azlinks_view')
        # Burn test
        self.assertEquals(view.results(), [])

    # from class AzLinkFolderView:
    def test_numberOfResults(self):
        view = self.az.restrictedTraverse('@@azlinks_view')
        # Burn test
        count = view.numberOfResults()
        # No nothing, so no results
        self.assertEquals(count, 0)

    # Manually created methods


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(testAzLinkFolderView))
    return suite

##code-section module-footer #fill in your manual code here
##/code-section module-footer

if __name__ == '__main__':
    framework()


